#include "inkey.ch"
#include "mrdebug.ch"

/*Ŀ
  Function Browser()                                                       
  Purpose  Example browse                                                  
  */
FUNCTION Browser(nTop AS INT, nLeft AS INT)

   LOCAL oBrowse, aArray, oColumn, nKey, oWindow, lFirst := .T.

   oWindow := Window():New(nTop, nLeft, 13, 34, "Tbrowse Window")

   aArray := {{"Press",     "Alt-D",   "here"},;
              {"and",       "then",    "in"},;
              {"MrDebug",   "press",   "Alt-L"},;
              {"to",        "toggle",  "local"},;
              {"variables", "on.",     "Press"},;
              {"Alt-4",     "to",      "switch"},;
              {"to",        "the",     "callstack"},;
              {"and",       "select",  "the"},;
              {"BROWSER",   "stack",   "item."},;
              {"Then",      "Alt-3",   "to"},;
              {"switch",    "to",      "the"},;
              {"Variable",  "window,", "and"},;
              {"select",    "the",     "oBrowse"},;
              {"variable",  "and",     "press"},;
              {"the",       "Enter",   "key."}}

   SetColor("W+/B")
   @ 0, 1 TO MaxRow(), 1

   oBrowse := abBrowse():New(0, 2, MaxRow(), MaxCol(), aArray)

   oBrowse:ColorSpec := "W+/B,N/W,N/B,G/B,R/B,RB/B,GR/B,W/B,N+/B,B+/B,G+/B,BG+/B,RB+/B,GR+/B"

   oColumn := tbColumnNew("One", {|| aArray[oBrowse:nElement][1] })
   oColumn:ColorBlock := {|| ColourFunc(oBrowse:nElement, 1) }
   oColumn:Width := 10
   oBrowse:AddColumn(oColumn)

   oColumn := tbColumnNew("Two", {|| aArray[oBrowse:nElement][2] })
   oColumn:ColorBlock := {|| ColourFunc(oBrowse:nElement, 2) }
   oColumn:Width := 10
   oBrowse:AddColumn(oColumn)

   oColumn := tbColumnNew("Three", {|| aArray[oBrowse:nElement][3] })
   oColumn:ColorBlock := {|| ColourFunc(oBrowse:nElement, 3) }
   oColumn:Width := 10
   oBrowse:AddColumn(oColumn)

   DO WHILE .T.
      IF lFirst
         lFirst := .F.
         oWindow:Display()
         DispBegin()
      ENDIF

      oBrowse:ForceStable():DisplayArrows()

      DispEnd()

      nKey := __Inkey(0)

      DispBegin()

      DO CASE
         CASE nKey == K_ESC
            EXIT

         OTHERWISE
            oBrowse:Handler(nKey)

      ENDCASE
   ENDDO

   DispEnd()

   oWindow:Close()

RETURN (NIL)

/*Ŀ
  Function ColourFunc                                                      
  Purpose  Guess at which colour would look really nasty here              
  */
STATIC FUNCTION ColourFunc(nElement, nColumn)
RETURN ({nElement * nColumn % 12 + 3, 2})
